let type_expr e =
  let t,l = Constr.build e in
  let s = Unif.unif (List.map (fun (x,y) -> (Type.to_unif x, Type.to_unif y)) l) in
    Type.of_unif (List.fold_left (fun x (i,x') -> Unif.replace x i x') (Type.to_unif t) s)

let _ =
  try
    let lexbuf = Lexing.from_channel stdin in
      while true do
	try
	  print_string "# "; flush stdout;
	  let e = Parser.expr Lexer.token lexbuf in
	    (* Expr.print e ""; *)
	    (* (let t,l = Infer.infer e (Env.create ()) in
	         Type.print t; print_newline ();
	         List.iter (fun (tx,ty) -> Type.print tx; print_string " = "; Type.print ty; print_newline ()) l;
	         let s = Unif.unif (List.map (fun (x,y) -> (Type.to_unif x, Type.to_unif y)) l) in
		   List.iter (fun (i,x) -> print_string "X"; print_int i; print_string " <- ";
			        Type.print (Type.of_unif x); print_newline ()) s); *)
	    Type.print (type_expr e); print_string " = ";
	    Val.print (Eval.eval e); print_newline ()
	with
	  | Eval.Error s -> print_string ("Eval error: "^s); print_newline ()
	  | Constr.Error s -> print_string ("Constraint error: "^s); print_newline ()
	  | Unif.Error s -> print_string ("Unification error: "^s); print_newline ()
      done
  with
    | Lexer.Lexing_error -> print_string "Lexing error."; print_newline ()
    | Parsing.Parse_error -> print_string "Parsing error."; print_newline ()
    | End_of_file -> print_string "In a while, crocodile!"; print_newline ()
