%{
  open Expr
%}

%token EOF
%token <int> INT
%token <bool> BOOL
%token <string> ID
%token PLUS MINUS TIMES DIV EQEQ GT NOT AND
%token IF THEN ELSE
%token LPAREN RPAREN
%token LET REC EQ IN FUN ARROW END
%token SCSC
%type <Expr.t> expr

/* priorit des oprateurs */
%nonassoc INT BOOL LPAREN IF LET FUN ID EOF
%left NOT AND
%left EQEQ GT
%left PLUS MINUS
%left TIMES DIV
%left APP

%start expr	/* point d'entre */

%%

expr:
| exp SCSC				{ $1 }
;

exp:
| INT				  	{ Int $1 }
| BOOL					{ Bool $1 }
| ID					{ Var $1 }
| LPAREN exp RPAREN			{ $2 }
| exp PLUS exp				{ Op (Add, [$1;$3]) }
| exp MINUS exp				{ Op (Sub, [$1;$3]) }
| exp TIMES exp				{ Op (Mul, [$1;$3]) }
| exp DIV exp				{ Op (Div, [$1;$3]) }
| exp EQEQ exp				{ Op (Eq, [$1;$3]) }
| exp GT exp				{ Op (Gt, [$1;$3]) }
| NOT exp				{ Op (Not, [$2]) }
| exp AND exp				{ Op (And, [$1;$3]) }
| IF exp THEN exp ELSE exp END		{ Op (If, [$2;$4;$6]) }
| LET ID EQ exp IN exp END		{ Let ($2,$4,$6) }
| LET REC ID EQ exp IN exp END		{ LetRec ($3,$5,$7) }
| FUN ID ARROW exp END			{ Fun ($2,$4) }
| exp exp %prec APP			{ App ($1,$2) }
| EOF					{ raise End_of_file }
;
