type t =
  | Int
  | Bool
  | Fun of t * t
  | Var of int

let new_var =
  let c = ref 0 in
    (fun () -> c := !c+1; Var !c)

let rec print = function
  | Int         -> print_string "Int"
  | Bool        -> print_string "Bool"
  | Fun (tx,ty) -> print_string "("; print tx; print_string " -> "; print ty; print_string ")"
  | Var i       -> print_string "X"; print_int i

let rec to_unif = function
  | Int         -> Unif.Cons ("Int", [])
  | Bool        -> Unif.Cons ("Bool", [])
  | Fun (tx,ty) -> Unif.Cons ("Fun", [to_unif tx; to_unif ty])
  | Var i       -> Unif.Var i

let rec of_unif = function
  | Unif.Cons ("Int", [])    -> Int
  | Unif.Cons ("Bool", [])   -> Bool
  | Unif.Cons ("Fun", [x;y]) -> Fun (of_unif x, of_unif y)
  | Unif.Var i               -> Var i
  | _                        -> failwith "Apocalypse has occured, please report."
